/********************************************************************
/*Name:		Shuang Xu
/*DePaul ID:	0255454
/*Course No:	SE455, Software Development Methods
/*Instructor:	Robert Stalzer
/*Project Name: Tetris
/*******************************************************************/

/*
Using SINGLETON for class Field, which is the baseclass of PlayingField, in order to 
ensure there is only one instance of Field, also provide a global point of access
to it.
*/

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.event.*;

public abstract class Field 
    	extends Canvas    
	implements Runnable
{ 	private static Field instance;

	public static Field getInstance() {
		if (instance == null) {
			instance = new PlayingField(10, 20, Color.black);
		}
		return instance;
	}
	
	public abstract boolean gameOver();
	public abstract boolean hitBottom(Shape s);
	public abstract boolean isInvading(FilledCells fc);
	public abstract boolean outOfBounds(FilledCells fc);

	public abstract int getCellWidth();
	public abstract int getCellHeight();
	public abstract int getNumberOfRows();
	public abstract int getNumberOfColumns();
	public abstract int getScore();
	public abstract int getLevel();

	public abstract KeyAdapter getKeyListener();

	public abstract void startNewGame();
	public abstract void stopGame();
	public abstract void suspendGame();
	public abstract void resumeGame();

}