/********************************************************************
/*Name:		Shuang Xu
/*DePaul ID:	0255454
/*Course No:	SE455, Software Development Methods
/*Instructor:	Robert Stalzer
/*Project Name: Tetris
/*******************************************************************/

/*
Using TEMPLATE METHOD for class MoveController, which is the baseclass of 
LeftKeyController, RightKeyController, UpKeyController and DropController.

For handling any movement, it has to perform the following actions:
	erase();
	action();
	draw();
although different event has different action(), the three steps have to be done in the same order.
*/

public abstract class MoveController 
{ 	protected Shape shape;

	public MoveController(Shape s) {
		if (s != null) shape = s;
	}
	
	public void display() {
		erase();
		action();
		draw();
	}

	public void erase() {
		shape.erasePreviousFigure(shape.getFilledCells());
	}

	public void draw() {
		shape.draw();
	}

	public abstract void action();

}

class LeftKeyController extends MoveController 
{ 
	public LeftKeyController(Shape s) {
		super( s );
	}
	
	public void action() {
		shape.setCoords( shape.getRow(), shape.getColumn() -1 );
	}
}

class RightKeyController extends MoveController 
{ 
	public RightKeyController(Shape s) {
		super( s );
	}
	
	public void action() {
		shape.rotate();
	}
}

class UpKeyController extends MoveController 
{ 
	public UpKeyController(Shape s) {
		super( s );
	}
	
	public void action() {
		shape.setCoords( shape.getRow(), shape.getColumn() + 1 );
	}
}

class DropController extends MoveController 
{ 
	public DropController(Shape s) {
		super( s );
	}
	
	public void action() {
		shape.advance();
	}
}