/********************************************************************
/*Name:		Shuang Xu
/*DePaul ID:	0255454
/*Course No:	SE455, Software Development Methods
/*Instructor:	Robert Stalzer
/*Project Name: Tetris
/*******************************************************************/

/*
class ShapeColorFactory is used as a parameterized FACTORY METHOD.
By overriding this parameterized factory method, we can easily and 
selectively extend or change the shape color that Create() produces. 
We can introduce new identifiers for new color of Shapes, or we can 
associate existing color with different shape objects.
*/

import java.awt.Graphics;
import java.awt.Color;

public class ShapeColorFactory  {
	protected int shapeNumber;

	public ShapeColorFactory(int shapeNum) {
		if (shapeNum>=0) shapeNumber = shapeNum;
	}
	
	public Color Create () {
		switch (shapeNumber) {
		       case 0:
			return new Color(Color.blue.darker().getRGB());
		       case 1:
			return new Color(Color.red.darker().getRGB());
		       case 2:
			return new Color(Color.green.darker().getRGB());
		       case 3:
			return new Color(Color.magenta.darker().getRGB());
		       case 4:
			return new Color(Color.cyan.darker().getRGB());
		       case 5:
			return new Color(Color.orange.getRGB());
		       case 6:
			return new Color(Color.pink.darker().getRGB());
		       default:
			return null;
		}
	}
}
