/********************************************************************
/*Name:		Shuang Xu
/*DePaul ID:	0255454
/*Course No:	SE455, Software Development Methods
/*Instructor:	Robert Stalzer
/*Project Name: Tetris
/*******************************************************************/

/*
class ShapeFactory is used as a parameterized FACTORY METHOD.
By overriding this parameterized factory method, we can easily and selectively
extend or change the shape object that Build() produces. We can introduce new
identifiers for new kinds of Shapes, or we can associate existing identifiers with
different shape objects.
*/


public class ShapeFactory  {
	protected int shapeNumber;
	protected Shape shape;
	public ShapeFactory(int shapeNum) {
		if (shapeNum>=0) shapeNumber = shapeNum;
	}
	
	public Shape Build() {
		switch (shapeNumber) {
		    case 0:
			shape = new LShape();
			return shape;
		    case 1:
			shape = new BackwardLShape();
			return shape;
		    case 2:
			shape = new StairShape();
			return shape;
		    case 3:
			shape = new CubeShape();
			return shape;
		    case 4:
			shape = new StickShape();
			return shape;
		    case 5:
			shape = new BackwardStairShape();
			return shape;
		    case 6:
			shape = new TShape();
			return shape;
		    default:
			shape = null;
			return shape;
		}
	}
}
